package com.streambase.contrib;

import java.util.ArrayList;
import java.util.List;

import com.streambase.sb.CompleteDataType;
import com.streambase.sb.client.CustomFunctionResolver;

public class addSimple {

	/**
	 * 
	 * @param vec1 the vector to add to
	 * @param vec2 the vector to add from
	 * @return a sum of the two vectors
	 */
	@CustomFunctionResolver("addCustomFunctionResolver0")
	public static List<Double> add(List<Double> vec1, List<Double> vec2) {
		if (vec1 == null && vec2 == null)
			return new ArrayList<Double>();
		else if (vec1 == null && vec2 != null)
			return vec2;
		else if (vec2 == null && vec1 != null)
			return vec1;
		else if (vec2.get(0) == null)
			return vec1;
		else {
			if (vec1.size() != vec2.size())
				return vec1;
			List<Double> result = new ArrayList<Double>();
			for (int i = 0; i < vec1.size(); i++){
				result.add(vec1.get(i) + vec2.get(i));
			
			}
		return result;
		}		
	}

	/**
	 * A StreamBase Custom Function Resolver Function. This method is used by 
	 * StreamBase for type checking.  Use this method
	 * to resolve functions that take lists or tuples as arguments 
	 * or return lists or tuples.  This method should be used to ensure the 
	 * data types of your function are correct.
	
	 * For custom functions that return simple types (the Java equivalents of the simple 
	 * StreamBase types: int, long, double, bool, string, blob, timestamp), the returned CompleteDataType
	 * must be the appropriate corresponding simple type (e.g., as returned by CompleteDataType.forInt()).
	 * For custom functions that return non-simple types (the Java equivalents of the non-simple
	 * StreamBase types: tuple, list), the returned CompleteDataType must fully describe the appropriate
	 * non-simple type (as returned by CompleteDataType.forTuple(Schema) or CompleteDataType.forList(CompleteDataType))
	 *{@see com.streambase.sb.client.CustomFunctionResolver}  
	 */
	public static CompleteDataType addCustomFunctionResolver0(
			CompleteDataType vec1, CompleteDataType vec2) {
		if (vec1.getElementType() == CompleteDataType.forDouble() && vec2.getElementType() == CompleteDataType.forDouble())
			return CompleteDataType.forList(CompleteDataType.forDouble());
		return null;
	}

}
