package com.streambase.contrib;

import java.util.List;

import com.streambase.sb.CompleteDataType;
import com.streambase.sb.DataType;
import com.streambase.sb.client.CustomFunctionResolver;

public class factors {

	/**
	 * 
	 * @param value the price * quantity of a security
	 * @param factors a list of factors to multiple the price with
	 * @return
	 */
	@CustomFunctionResolver("mapFactorCustomFunctionResolver0")
	public static Double mapFactor(Double value, List<Double> factors) {
		if (value == null || factors == null)
			return -1.0;		
		double total = 0;
		for (Double factor : factors){
			total += value*factor;
		}
		return total;
	}
	
	public static CompleteDataType mapFactorCustomFunctionResolver0(
			CompleteDataType value, CompleteDataType type) {
		if (value.getDataType() == DataType.DOUBLE  && type.getElementType() == CompleteDataType.forDouble())
			return CompleteDataType.forDouble();
		return null;
	}

}
